<template>
  <div class="tenders-list-wrapper">
    <ObTable
      is-fixed-header
      ref="tenders-table"
      :remoteOpt="{
        method: api.tenders.getTenders,
        contentKey: 'tenders',
        arguments: getArguments()
      }"
      :columns="columns"
      :functionalPanel="true"
      :tableLayoutFixed="true"
      :filterButtons="selectedTab.name === 'archive' ? [] : filterButtons"
      :addButtons="addButtons"
      :addButtonsOptions="addButtonsOptions"
      :is-functional-group="false"
      :is-functional-sort="false"
      @add="onAdd"
      @select="onSelect"
      @on-change-filter-button="onChangeFilterButton"
      @on-load-list="onTableDataload"
      data-qa="tendersTable"
    >
      <template
        v-if="userIsBuyer && selectedTab.name !== 'archive'"
        slot="noneContent"
      >
        <div class="empty-content">
          <div class="empty-content-title">Здесь еще нет ни одной записи</div>

          <div
            v-if="selectedTab.type === 'RFQ' || !selectedTab.type"
            class="empty-content-button-container"
          >
            <ObButton
              type="flat"
              label="Создать RFQ"
              @click="onAdd({ type: 'rfq'})"
              data-qa="btnAddRFQ"
            />
          </div>

          <div
            v-if="selectedTab.type === 'RFI' || !selectedTab.type"
            class="empty-content-button-container"
          >
            <ObButton
              type="flat"
              label="Создать RFI"
              @click="onAdd({ type: 'rfi'})"
              data-qa="btnAddRFI"
            />
          </div>
        </div>
      </template>

      <div
        slot="menu"
        slot-scope="{ data }"
        @mouseover="onTenderMenuHover"
        @mouseleave="onTenderMenuLeave"
      >
        <TenderMenu
          :data="data.item"
          compact-mode
          @toggle="onMenuToggle(data)"
          @load-data="loadData"
        />
      </div>
    </ObTable>

    <ObModal
      ref="tenders-modal"
      size="medium"
      :key="modalKey"
      :title="`Добавление ${addingTenderType.toUpperCase()} тендера`"
      data-qa="tendersModal"
      str-confirm-modal-title="Вы точно хотите отменить создание тендера?"
      str-confirm-modal-text="При отмене все введенные данные будут потеряны"
      str-confirm-modal-ok-button="Да, отменить"
      str-confirm-modal-cancel-button="Не отменять"
    >
      <AddTemplate
        :type="addingTenderType"
        @save="onSave"
        @close="onCloseAddModal"
      />
    </ObModal>
  </div>
</template>

<script>
  import AddTemplate from '../modal/add.vue';
  import TenderMenu from '../components/tenderMenu';

  import ObTable from 'common-components/src/obComponents/obTable';
  import ObButton from 'common-components/src/obComponents/obButton';
  import ObModal from 'common-components/src/obComponents/obModal';

  import { mapGetters } from 'vuex';
  import { columns } from '../mock';
  import { uuid } from 'vue-uuid';
  import api from '@/api';

  export default {
    name: "tenders-tab-list",
    components: {
      ObTable,
      ObButton,
      TenderMenu,
      ObModal,
      AddTemplate
    },
    data () {
      return {
        api,
        tenderTimer: null,
        addingTenderType: '',
        modalKey: 1,
        filterButtons: [
          {
            type: null,
            title: 'Все',
            name: 'all',
            _isActive: false,
          },
          {
            type: 'relevant',
            title: 'Актуальные',
            name: 'relevant',
            _isActive: true,
          },
          {
            type: 'irrelevant',
            title: 'Неактивные',
            name: 'irrelevant',
            _isActive: false,
          }
        ]
      }
    },
    props: {
      selectedTab: {
        type: Object,
        required: true
      }
    },
    watch: {
      'selectedTab.name': {
        handler () {
          this.loadData();
        },
        immediate: true
      }
    },
    computed: {
      ...mapGetters({
        currentRole: 'tenders/currentRole'
      }),
      tendersFilter: ({ $route }) => $route?.query?.tenders_filter || 'relevant',
      userIsBuyer: ({ currentRole }) => currentRole === 'client',
      columns: ({ currentRole }) => currentRole ? [...columns[currentRole]] : [],
      selectedFilterButton: ({ filterButtons }) => filterButtons.find(button => button._isActive),
      addButtons: ({ userIsBuyer, selectedTab }) => {
        if (selectedTab.name === 'archive') {
          return []
        }

        const buttons = [{
          text: selectedTab.type === 'RFQ' ? 'Создать RFQ' : 'RFQ (Request for quotation)',
          type: 'rfq'
        },
          {
            text: selectedTab.type === 'RFI' ? 'Создать RFI' : 'RFI (Request for information)',
            type: 'rfi'
          }];

        return userIsBuyer ? selectedTab.type ? buttons.filter(button => button.type === (selectedTab.type).toLowerCase()) : buttons : null;
      },
      addButtonsOptions: ({ userIsBuyer, selectedTab }) => {
        return {
          group: userIsBuyer && !selectedTab.type,
          text: 'Создать тендер'
        }
      }
    },
    created() {
      if (!this.userIsBuyer) {
        this.filterButtons.unshift({
          type: 'urgent',
          name: 'urgent',
          html: '<i class="icon clock"></i>',
          _isActive: false
        });
      }
    },
    beforeMount() {
      this.onChangeFilterButton(this.filterButtons.find(button => button.name === this.tendersFilter))
    },
    beforeDestroy() {
      clearInterval(this.tenderTimer)
    },
    methods: {
      async onTableDataload() {
        this.startTimer();
      },
      startTimer() {
        const secondsToReadableString = (seconds) => {
          var days = Math.floor(seconds / (3600*24));
          seconds  -= days*3600*24;
          var hrs   = Math.floor(seconds / 3600);
          seconds  -= hrs*3600;
          var mnts = Math.floor(seconds / 60);
          return mnts ? `${days ? days + ' д' : ''} ${hrs ? hrs + ' ч ' : ''} ${mnts + ' мин'}` : `${seconds} сек`
        }

        const calculate = () => {
          this.$refs['tenders-table']?.localItems.filter(item => item.validityPeriod).forEach(item => {
            if (!item.hasOwnProperty('_seconds')) item._seconds = Math.abs(parseInt(item.validityPeriod));

            if (item._seconds !== 0 && item.validityPeriod !== '–') {
              item._seconds = item._seconds - 1;
              item.validityPeriod = secondsToReadableString(item._seconds);
            } else {
              item.validityPeriod = '–';
            }
          })
        };

        clearInterval(this.tenderTimer);

        this.tenderTimer = setInterval(() => {
          calculate();
        }, 1000);

        calculate();
      },
      loadData() {
        this.$nextTick(() => {
          this.$refs['tenders-table']?.loadData({ init: true });
        })
      },
      getArguments() {
        if (this.selectedTab.name === 'archive') {
          return { archived: true }
        }

        return {
          statuses: this.selectedFilterButton.type,
          type: this.selectedTab.type
        }
      },
      // 👂 Events
      onSelect(item) {
        if (this.isTenderMenuHovered) {
          return;
        }

        this.$router.push({ path: `/tenders/${item.uuid}`, query: { ...this.$route.query } });
      },
      onAdd({ type }) {
        this.addingTenderType = type;
        this.$refs["tenders-modal"].open();
      },
      onCloseAddModal() {
        this.modalKey++;
      },
      onChangeFilterButton(e) {
        if (this.$route.query.tenders_filter !== e.name) {
          this.$router.replace({
            ...this.$route,
            query: {
              ...this.$route.query,
              tenders_filter: e.name
            }
          })
        }

        this.filterButtons.map(button => button._isActive = false);

        e._isActive = true;

        this.loadData();
      },
      onMenuToggle (item) {
        const row = this.$refs['tenders-table'].$children.find(({ data }) => data === item)

        if (row) {
          row.$el.classList.toggle('with-opened-menu')
        }
      },
      onTenderMenuHover () {
        this.isTenderMenuHovered = true
      },
      onTenderMenuLeave () {
        this.isTenderMenuHovered = false
      },
      async onSave(data) {
        const payload = {
          ...data,
          tenderUuid: uuid.v4()
        };

        payload[this.addingTenderType === 'rfq' ? 'requestUuid' : 'questionnaireUuid'] = uuid.v4();

        await api.tenders.createTenderByType(this.addingTenderType, payload);

        this.$refs["tenders-modal"].close();

        await this.$router.push({
          name: "tenders__tenders__tender",
          params: { uuid: payload.tenderUuid }
        });
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import "~common-components/src/assets/style/ob-style";
  @import "~common-components/src/static/css/mixins";

  .empty-content {
    transform: none !important;
  }

  .empty-content-title {
    margin-bottom: 20px;
  }

  .empty-content-button-container {
    width: 200px;
    margin: 0 auto 10px;
    display: flex;
    justify-content: center;
  }

  ::v-deep {
    .tender-menu {
      opacity: 0;

      &.--opened {
        opacity: 1;
      }
    }

    .data-row {
      &.with-opened-menu td:last-child {
        z-index: 2;
      }

      td:last-child {
        position: sticky;
        right: 0;
        z-index: 1;
      }

      &:hover {
        td:last-child {
          background: linear-gradient(270deg, $light-lavender 81.25%, rgba($light-lavender, 0) 100%);
        }

        .tender-menu {
          opacity: 1;
        }
      }
    }

    .table-data tr > td {
      position: relative;
    }

    .red-countdown {
      color: red;
    }

    .tender-active-triangle {
      position: absolute;
      top: 0;
      left: 0;
      border: 10px solid transparent;
      border-left: 10px solid $color-green-light;
      border-top: 10px solid $color-green-light;
    }

    .tender-code-container {
      display: flex;
      align-items: center;
      white-space: nowrap;

      .icon.clock {
        margin-right: 10px;
      }
    }

    .icon.clock {
      font-size: 17px;

      &.transparent {
        opacity: 0;
        pointer-events: none;
      }

      &:before {
        color: $color-error
      }
    }

    .responsible-name {
      font-size: 14px;
      color: $tendersPage-responsible_name;
    }

    .field-datetime {
      @include font-mixin(14px, 20px, 400);
    }

    .field-time {
      color: $color-grey-span;
    }
  }
</style>